CC=gcc
FC=gfortran
MKLROOT=/opt/intel/mkl

CCFLAG=-O3 -mtune=native -march=native -fopenmp
FCFLAG=-O3 -mtune=native -march=native -fopenmp

LIB=-L../../lapack-3.9.1 -llapack -lrefblas -lm

all: clean RESL.o CGS2.o DGEBRDG_4_TRISIDE.o ERR.o dfma0.o RESL_MAIN.o fileinput_l oneone

%.o: lib/%.f
	${FC} ${FCFLAG} -c -o lib/$@ $<

%.o: src/%.f90
	${FC} ${FCFLAG} -c -o src/$@ $<

dfma0.o:
	${CC} ${CCFLAG} -c -o lib/dfma0.o lib/dfma0.c

fileinput_l:
	${FC} ${FCFLAG} -o fileinput_l fileinput_l.f src/CGS2.o src/DGEBRDG_4_TRISIDE.o src/RESL.o src/ERR.o lib/dfma0.o src/RESL_MAIN.o ${LIB}

oneone:
	${CC} ${CCFLAG} -o oneone oneone.c

clean:
	rm -rf src/*.o lib/*.o fileinput_l oneone

