SUBROUTINE RESL_MAIN(ini,method,LS,ACCURACY,L,K)
  use my_data
  use omp_lib
  IMPLICIT NONE

  INTEGER LS
  DOUBLE PRECISION TM(K,K),VK(M,K),VPLUS(M)
  DOUBLE PRECISION IDEN(l,l),OERR
  DOUBLE PRECISION MIN_ERR,TMP_ERR,TAVE,STARTT,TMPT,MINT,CONST,ZERO,ONE,TWO,TEN,ERR,DNRM2,TMAX
  PARAMETER (ZERO = 0.0D+0,ONE = 1.0D+0,TWO = 2.0D+0,TEN = 10.0D+0)
  INTEGER ISEED(4),ini,method,j
  INTEGER L,K,COU,ACCURACY,I,ITR

  ISEED( 1 ) = ini
  ISEED( 2 ) = 402+ini*13
  ISEED( 3 ) = 2+ini*3
  ISEED( 4 ) = 111+ini*7
  print *, "MODE = ",MODE
  WRITE (*,*) "M K L"
  WRITE (*,*) M,K,L

  CONST = TEN**(ZERO - accuracy)
  if(M<K) then
     print *,"! ERR L must be smaller than",M
  end if

  s0 = ZERO
  opcount = 0
  CALL DLARNV(1,ISEED,M,VPLUS)
  VPLUS = VPLUS / DNRM2(M,VPLUS,1)

  STARTT = omp_get_wtime()
  WRITE(*,*) 
  TM = ZERO
  VK = ZERO
  MIN_ERR = -ONE
  COU = 0
  ITR = 0
  I = 0
  DO WHILE (COU < 10000)

     CALL RESL(I,LS,L,K,TM,VK,VPLUS,METHOD)

     TMP_ERR = MAXVAL(ABS(TM(1:L,L+1)))

     ITR = ITR+1
     TMPT = omp_get_wtime()
     IF ( (TMP_ERR < MIN_ERR) .OR. (MIN_ERR .EQ. -ONE) ) THEN
        MIN_ERR = TMP_ERR
        MINT = TMPT
        COU = -1
     END IF
     
     WRITE(*,*) METHOD,ITR,(TMPT-STARTT),TMP_ERR
     IF(TMP_ERR .LE. CONST) exit
     COU = COU + 1
  END DO

  TAVE = ERR(L,K,TM,VK,WORK,TMAX)

  IDEN = ZERO
  DO I = 1, L
     IDEN(I,I) = -ONE
  END DO
  CALL DSYRK('U','T',L,M,ONE,VK,M,ONE,IDEN,L)
  OERR = ZERO
!$OMP PARALLEL DO PRIVATE( J ) REDUCTION( +:OERR )
  DO I = 2, L
     DO J = 1, I-1
        OERR = OERR + IDEN(J,I)**2
     ENDDO
  ENDDO
!$OMP END PARALLEL DO
  OERR = TWO*OERR
  DO I = 1, L
     OERR = OERR + IDEN(I,I)**2
  ENDDO
  WRITE(*,*) "OERR VK",SQRT(OERR)
  
  WRITE(*,*) "TIME", METHOD,ITR,(TMPT-STARTT),TMP_ERR,"AVE",TAVE,"MAX",TMAX
  WRITE(*,*) "MATRIX VECTOR COMPUTATION (sec)",s0
  WRITE(*,*) "Total number of OP*x operations  :",opcount

  DO I = 1,L
     WRITE (*,*) "EigenValue",I, TM(I,I)
  END DO

END SUBROUTINE RESL_MAIN
